<?
include_once("XmlPhp.php");

/*===============================================================
Esta clase implementa la apariencia y comportamiento de un treeview en cdigo HTML y javascript.
La clase utiliza la clase XmlPhp.php para acceder al documento XML. 

	Parmetros del constructor:
		-fXML=Fichero XML
		-fileocade=Indica si el dato anterior es un fichero o una variable con el contenido del rbol	
			0: Es una cadena
			1: Es un fichero
		-baseurlimg= Url base de las imgenes de los nodos de contraccin-expansin
		-clasedefault=Clase por defecto de los literales de los nodos
		-nivelexp= Mximo nivel que aparecera expandido 
		-x= Posicin x donde aparecer la tabla 
		-y= Posicin y donde aparecer la tabla 
=================================================================*/
class ArbolVistaXML{

	var $baseurlimg;	// Base de la URL de las imgenes de los nodos de contraccin-expansin
	var $clasedefault;	// Clase por defecto de los literales de los nodos
	var $gXML;			// Objeto gestor del documento XML
	var $nivelexp;		// Nivel mximo que aprecer visible
	var $x;		// Posicin x donde aparecer la tabla 
	var $y;		// Posicin y donde aparecer la tabla 
	var $c_imgnivel=array();	// Imagenes de expansin y contraccin para los distintos niveles
	var $v_imgnivel=array();	// Valores de expansin y contraccin para los distintos niveles
	var $nodos_count;	// Contador de nodo

	Function ArbolVistaXML($fXML,$fileocade,$baseurlimg="/.images/",$clasedefault,$nivelexp=0,$x=0,$y=0,$tipotabla=0,$titulotabla=""){
		// Constructor
		$this->gXML=new XmlPhp($fXML,$fileocade);
		$this->baseurlimg=$baseurlimg;
		$this->clasedefault=$clasedefault;
		$this->nivelexp=$nivelexp;
		$this->x=$x;
		$this->y=$y;
		$this->tipotabla=$tipotabla;
		$this->titulotabla=$titulotabla;

		// Anchura de los distibtos tipos de tablas
		if($this->tipotabla>0){
			$this->anchoM=" width=100% ";
			$this->ancho=" width=100% ";
		}
		else{
			$this->anchoM=" width=1024 ";
			$this->ancho="";
		}
		for($i=0;$i<=5;$i++){ // Inicializar 
			$this->c_imgnivel[$i]=$this->baseurlimg.'/nada.gif';
			$this->v_imgnivel[$i]="nada";
		}
		$this->nodos_count=0;
	}
	/*------------------------------------------------------------------------------------------------
		Esta funcin devuelve una cadena con el contenido de un treeview en cdigo HTML
	------------------------------------------------------------------------------------------------*/
	Function CreaArbolVistaXML(){
		if (!$this->gXML->NodoRaiz()) return; // No existe documento XML que analizar
		$arbol_total='<TABLE  '.$this->anchoM.' class="'.$this->clasedefault. '" style="position:absolute;top='.$this->y.'px;left='.$this->x.'px" class=texto_arbol cellspacing=0 cellpadding=0 border=0>';
		if($this->tipotabla>0) $arbol_total.=chr(13).'<TR><TH>'. $this->titulotabla .'</TH></TR>';
		$arbol_total.=chr(13).'<TR style="display:block"><TD><TABLE width=100% id=tablanivel-0 border=0 cellspacing=0 cellpadding="0">';
		$arbol_total.=$this->_arbolXmlrecur(0);
		$arbol_total.=chr(13).'</TABLE></TD></TR>';	
		$arbol_total.='</TABLE>';
		$arbol_total.='<INPUT id="nodo_count" value='.$this->nodos_count.' type=hidden>'; // Para controlar el fin del arbol
		return($arbol_total);
	}
	// -------------------------------------------------------------------------------------
	// Recorrido recursivo del arbol XML
	//		Parmetros: 
	//			nivel: nivel del nodo
	// -------------------------------------------------------------------------------------
	function _arbolXmlrecur($nivel){
		$arbol_total="";
		if ($nivel+1>$this->nivelexp) $displai="none"; else $displai="block";
		do{
			$gnptr=$this->gXML->nptr;
			$arbol_total.=chr(13).'<TR id=TRNodo-'.$this->nodos_count.'><TD>'.$this->_dibujo_nodo($this->gXML->Nodo(),$nivel,$this->gXML->NumerodeHijos(),$this->gXML->EsUltimoHermano()).'</TD></TR>';
			$this->nodos_count++;
			if ($this->gXML->PrimerNodoHijo()){
				$arbol_total.=chr(13).'<TR style="display:'.$displai.'"><TD><TABLE width=100% id="tablanivel-'.($nivel+1).'" border=0 cellspacing=0 cellpadding=0>';
				$arbol_total.=$this->_arbolXmlrecur($nivel+1);
				$arbol_total.=chr(13).'</TABLE></TD></TR>';	
			}
			$this->gXML->nptr=$gnptr;
		}while($this->gXML->SiguienteNodoHermano());
		return($arbol_total);
	}
	/*------------------------------------------------------------------------------------------------
		Dibuja los nodos del rbol 
			parmetros:
				nodo: La informacin del nodo
				nivel: Nivel del nodo
				nhijos: numero de hijos
				uhermano: Es true si el nodo es el ltimo de sus hermanos

			Especificaciones:
				Los atributos de los nodos pueden ser HTML o especificos de
				esta aplicacin. Lso atributos del nodo propios de sta son:

					- clicksupimg: Funcin suplementaria de la imagen de signo
					- imagenid: Identificador de la imagen de signo
					- clickimg: La funcin que se ejecutar al hacer click sobre la imagen de nodo
					- downimg: La funcin que se ejecutar al pulsar el ratn  sobre la imagen de nodo
					- clickcontextualimg: Funcin que se ejecutara al hacer click con el boton derecho sobre la imagen del nodo
					- imagenodo: Es la url de la imagen de nodo
					- infonodo: Es texto que se visualiza del nodo
					- mouseovernodo: La funcin a ejecutar cuando se posa el ratn sobre el literal del nodo
					- clicksupnodo: Funcin suplementaria del literal del nodo
					- clickcontextualnodo: Funcin que se ejecutara al hacer click con el boton derecho sobre el nodo
					- classnodo: Clase (style) a  la que pertenece el nodo
					- nodoid: identificador del nodo
					- nodovalue: parametro value del nodo
	------------------------------------------------------------------------------------------------*/
	function _dibujo_nodo($nodo,$nivel,$nhijos,$uhermano){
		// Comprobar descendencia y posicin dentro de los hermanos
		$swu=false; // switch para saber si el nodo es el ltimo hermano
		$swh=false; // switch para saber si el nodo tiene hijos
		if ($nhijos>0) $swh=true;
		$swu=$uhermano;
		if ($swh){	// Si tiene hijos ..
			if ($swu){ // Si es el ltimo de sus hermanos ..
				if ($nivel<$this->nivelexp){
					$this->c_imgnivel[$nivel]=$this->baseurlimg.'/menos_c.gif';
					$this->v_imgnivel[$nivel]="menos_c";
				}
				else{
					$this->c_imgnivel[$nivel]=$this->baseurlimg.'/mas_c.gif';
					$this->v_imgnivel[$nivel]="mas_c";
				}
			}
			else{		// Si NO lo es ..
				if ($nivel<$this->nivelexp){
					$this->c_imgnivel[$nivel]=$this->baseurlimg.'/menos_t.gif';
					$this->v_imgnivel[$nivel]="menos_t";
				}
				else{
					$this->c_imgnivel[$nivel]=$this->baseurlimg.'/mas_t.gif';
					$this->v_imgnivel[$nivel]="mas_t";
				}
			}
			if ($nivel==0){
				if ($this->nivelexp>0)
					$this->c_imgnivel[$nivel]=$this->baseurlimg.'/menos_root.gif';
				else
					$this->c_imgnivel[$nivel]=$this->baseurlimg.'/mas_root.gif';
			}
		}
		else{		// Si NO tiene hijos ..
			if ($swu){	// Si es el ltimo de sus hermanos ..
				$this->c_imgnivel[$nivel]=$this->baseurlimg.'/nada_c.gif';
				$this->v_imgnivel[$nivel]="nada_c";
			}
			else{		// Si no lo es ..
				$this->c_imgnivel[$nivel]=$this->baseurlimg.'/nada_t.gif';
				$this->v_imgnivel[$nivel]="nada_t";
			}
		}
		// Fin Comprobar descendencia y posicin dentro de los hermanos
		if($this->tipotabla==0)
			$arbol='<TABLE  border=0 cellspacing=0 cellpadding=0>'.chr(13);
		else
			$arbol='<TABLE width=100% style="BORDER-BOTTOM:#000000 1px solid;" border=0 cellspacing=0 cellpadding=0>'.chr(13);

		$arbol.='<TR height="16px">'.chr(13);

		$atributosHTML=" ";
		$atributosHTML=$this->gXML->Atributos($nodo);

		$colornodo="";
		$fondonodo="";
		$estilo="";

		$atributosHTML=$this->gXML->TomaAtributoEspecial("colornodo",$colornodo,$atributosHTML);
		$atributosHTML=$this->gXML->TomaAtributoEspecial("fondonodo",$fondonodo,$atributosHTML);

		if ($colornodo!="" ) $colornodo=' COLOR:'.$colornodo.";";
		if ($fondonodo!="" ) $fondonodo=' BACKGROUND-COLOR:'.$fondonodo.";";
		$estilo=$colornodo || $fondonodo;
		if ($estilo!="" )	$estilo='style="'.$colornodo.$fondonodo.'"';

		for ($i=0;$i<$nivel;$i++){ // Niveles previos
			$arbol.='<TD  '.$estilo.'width="3px"></TD>'.chr(13);
			$arbol.='<TD  '.$estilo.' width="16px"><IMG src="'.$this->c_imgnivel[$i].'" width="16px" height="16px" ></TD>'.chr(13);
		}
		$arbol.='<TD  '.$estilo.' width="3px"></TD>'.chr(13); // Desplazamiento de la imagen
		$arbol.='<TD  '.$estilo.' width="16px">'.chr(13);
		
		$imagenid="";
		$clicksupimg="";
		$atributosHTML=$this->gXML->TomaAtributoEspecial("imagenid",$imagenid,$atributosHTML);
		$atributosHTML=$this->gXML->TomaAtributoEspecial("clicksupimg",$clicksupimg,$atributosHTML);
		if ($clicksupimg!="") $clicksupimg.=';';
		if ($swh){ // El nodo tiene hijos
			$arbol.='<IMG  '.$estilo.' id="'.$imagenid.'" style="cursor:hand" onclick="clickImagenSigno(this,' ."'".$this->baseurlimg."'".','.$nivel.');'.$clicksupimg.'"  src="'.$this->c_imgnivel[$nivel].'" width="16px" height="16px" value="'.$this->v_imgnivel[$nivel].'"></TD>'.chr(13);
		}
		else
			$arbol.='<IMG  '.$estilo.' id="'.$imagenid.'" src="'.$this->c_imgnivel[$nivel].'" width="16px" height="16px" value="'.$this->v_imgnivel[$nivel].'"></TD>'.chr(13);

		$imagenodo="";
		$clickimg="";
		$downimg="";
		$clickcontextualimg="";
		$styleimg="";
		
		$atributosHTML=$this->gXML->TomaAtributoEspecial("imagenodo",$imagenodo,$atributosHTML);
		$atributosHTML=$this->gXML->TomaAtributoEspecial("clickimg",$clickimg,$atributosHTML);
		$atributosHTML=$this->gXML->TomaAtributoEspecial("downimg",$downimg,$atributosHTML);
		$atributosHTML=$this->gXML->TomaAtributoEspecial("clickcontextualimg",$clickcontextualimg,$atributosHTML);
		if ($clickimg!="" ) $clickimg=' onclick="'.$clickimg.'" ';
		if ($downimg!="" ) $downimg=' onmousedown="'.$downimg.'" ';
		if ($clickcontextualimg!="" ) $clickcontextualimg=' oncontextmenu=" '.$clickcontextualimg.'" ';

		if ($clickimg!="" || $downimg!="" || $clickcontextualimg!="" ) $styleimg=' style="cursor:hand"';

		$arbol.='<TD  '.$estilo.' width=16px><IMG '.$styleimg.' src="'.$imagenodo.'"'.$clickimg.$downimg.$clickcontextualimg.' width="16px" height="16px"></TD>'.chr(13); 
		$arbol.='<TD  '.$estilo.' width="4px"></TD>';

		$clicksupnodo="";
		$clickcontextualnodo="";
		$classnodo="";
		$nodoid="";
		$nodovalue="";
		$mouseovernodo="";
		$infonodo="";

		$atributosHTML=$this->gXML->TomaAtributoEspecial("clickcontextualnodo",$clickcontextualnodo,$atributosHTML);
		$atributosHTML=$this->gXML->TomaAtributoEspecial("clicksupnodo",$clicksupnodo,$atributosHTML);
		$atributosHTML=$this->gXML->TomaAtributoEspecial("classnodo",$classnodo,$atributosHTML);
		$atributosHTML=$this->gXML->TomaAtributoEspecial("nodoid",$nodoid,$atributosHTML);
		$atributosHTML=$this->gXML->TomaAtributoEspecial("nodovalue",$nodovalue,$atributosHTML);
		$atributosHTML=$this->gXML->TomaAtributoEspecial("colornodo",$colornodo,$atributosHTML);
		$atributosHTML=$this->gXML->TomaAtributoEspecial("fondonodo",$fondonodo,$atributosHTML);
		$atributosHTML=$this->gXML->TomaAtributoEspecial("mouseovernodo",$mouseovernodo,$atributosHTML);
		$atributosHTML=$this->gXML->TomaAtributoEspecial("infonodo",$infonodo,$atributosHTML);
		if ($clickcontextualnodo!="" ) $clickcontextualnodo=' oncontextmenu="'.$clickcontextualnodo.'" ';
		if ($mouseovernodo!="" ) $mouseovernodo=' onmouseover="'.$mouseovernodo.'" ';
		if ($nodovalue!="" ) $nodovalue=' value="'.$nodovalue.'" ';
		if (!$classnodo) $classnodo=$this->clasedefault;
		
		$arbol.='<TD  '.$estilo.' id="'.$nodoid.'" class="'.$classnodo;
		if($this->tipotabla<2)
			$arbol.='"  style="cursor:hand"  onclick="clickLiteralNodo(this ,' ."'".$this->baseurlimg."'".');';
		$arbol.=" ".$clicksupnodo.'"'.$nodovalue.$mouseovernodo.$clickcontextualnodo.'>'.$infonodo.'</TD>'.chr(13);
		$arbol.='</TR>'.chr(13);
		$arbol.='</TABLE>'.chr(13);
		if ($swu)
			$this->c_imgnivel[$nivel]=$this->baseurlimg.'/nada.gif';
		else
			$this->c_imgnivel[$nivel]=$this->baseurlimg.'/nada_l.gif';
		return($arbol);
	}
} // Fin de la clase 